import logging
import subprocess

def execute(func, waiting=True):
    logging.error("Running command: %s" % " ".join(func))
    p = subprocess.Popen(func, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    if waiting:
        (stdout, stderr) = p.communicate()
        if stdout != "":
            logging.error("Command output: %s" % stdout)
        if stderr != "":
            logging.error("Command errors: %s" % stderr)
        return (stdout, stderr)
    else:
        return p
