from executer import execute
import os
import optparse
import sys
import util

def viterbi(source_folder, target_folder, filelist, dictionary, wordnet, modellist):
    util.make_dir(target_folder)
    stdout, stderr = execute(['HVite',
        '-H', os.path.join(source_folder, 'hmmdefs'),
        '-H', os.path.join(source_folder, 'macros'),
        '-S', filelist,
        '-i', os.path.join(target_folder, 'output.mlf'),
        '-w', wordnet,
        dictionary, modellist])
    target = target_folder.split("/")[1]
    util.make_dir('prores/%s' % target)
    fo = open('prores/%s/output' % target, 'w')
    fo.write(stdout)
    fo.close()




if __name__=='__main__':
    parser = optparse.OptionParser()
    parser.add_option("-s", "--source", dest="source",
            help="Source folder(s)")
    parser.add_option("-f", "--file-list", dest="filelist",
            help="File list")
    parser.add_option("-t", "--target", dest="target",
            help="Target folder(s)")
    parser.add_option("-d", "--dictionary", dest="dictionary",
            help="Dictionary")
    parser.add_option("-w", "--wordnet", dest="wordnet",
            help="Word network")
    parser.add_option("-m", "--modellist", dest="modellist",
            help="Model list")
    (options, args) = parser.parse_args()
    source_folders = options.source.split(",")
    target_folders = options.target.split(",")
    if len(source_folders) != len(target_folders):
        print "Need the same amount of source and target folders"
        sys.exit(1)
    for i, source_folder in enumerate(source_folders):
        viterbi(source_folder, target_folders[i],
                options.filelist,
                options.dictionary,
                options.wordnet,
                options.modellist)
